/**
 * Author: Andrei Heidelbacher
 * Task: Network
 * Grader
 */

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>

#include <string>

using namespace std;

const char OK_FILE[] = "network.ok";
const char OUT_FILE[] = "network.out";
const double EPS = 0.00001;

inline void result(const int score, const string message) {
  fprintf(stdout, "%d %s\n", score, message.c_str());
  exit(0);
}

inline void require(const bool condition, const string message) {
  if (!condition)
    result(0, message);
}

inline double absoluteErr(const double x, const double y) {
  return abs(x - y);
}

inline bool equals(const double x, const double y) {
  return absoluteErr(x, y) <= EPS;
}

int main() {
  FILE *fok = fopen(OK_FILE, "r");
  require(fok != NULL, "Fisier .ok lipsa!");
  double realP0, realP1;
  require(fscanf(fok, "%lf\n%lf", &realP0, &realP1) == 2, "Fisier .ok corupt!");
  fclose(fok);

  FILE *fout = fopen(OUT_FILE, "r");
  require(fout != NULL, "Fisier de iesire lipsa!");
  double p0, p1;
  require(fscanf(fout, "%lf\n%lf", &p0, &p1) == 2, "Fisier de iesire corupt!");
  fclose(fout);

  if (equals(realP0, p0) && equals(realP1, p1))
    result(10, "Ok!");
  else
    result(0, "Raspuns incorect!");
  return 0;
}
