#include <fstream>
#include <cassert>
#include <ctime>
#include <iostream>
#include <vector>
#include <cstring>
#include <queue>
#include <cmath>

using namespace std;

ifstream f("shuffle.in");
ofstream g("shuffle.out");

int mod = (1.e9) + 7;
const int Nmax = 200000;
const int Mmax = 300000;

const int N = Nmax + 10;
const int M = Mmax + 10;

vector<int> v[N], r[N], niv[N];
queue<int> q;
int viz[N], D[2][N], n, m, I[N], P[N], x, y, edges_cnt, lvl_cnt, nod_cnt, dp[N];

void bfs(vector<int> v[N], int x, int p) {
    memset(D[p], 0, sizeof(D[p]));
    memset(viz, 0, sizeof(viz));
    q.push(x);
    viz[x] = 1;
    while (!q.empty()) {
        x = q.front();
        q.pop();
        for (auto &it : v[x]) {
            if (!viz[it]) {
                viz[it] = 1;
                q.push(it);
                D[p][it] = D[p][x] + 1;
            }
        }
    }
}
void bf(int x) {
    q.push(x);
    memset(viz, 0, sizeof(viz));
    viz[x] = 1;
    niv[1].push_back(x);
    while (!q.empty()) {
        x = q.front();
        q.pop();
        for (auto &it : v[x]) {
            if (!viz[it]) {
                viz[it] = viz[x] + 1;
                niv[viz[it]].push_back(it);
                q.push(it);
            }
        }
    }
}
int lgput(int x, int y){
    int sol = 1;
    while (y) {
        if (y & 1) {
            sol = 1LL * sol * x % mod;
        }
        x = 1LL * x * x % mod;
        y >>= 1;
    }
    return sol;
}
int comb(int x, int y) {
    return 1LL * P[x] * I[y] % mod * I[x - y] % mod;
}
int main () {
    f >> n >> m;
    assert(n >= 1 && n <= Nmax);
    assert(m >= 1 && m <= Mmax);
    P[0] = 1;
    for (int i = 1; i <= m; ++i) {
        P[i] = 1LL * P[i - 1] * i % mod;
    }
    I[m] = lgput(P[m], mod - 2);
    for (int i = m - 1; i >= 0; --i) {
        I[i] = 1LL * I[i + 1] * (i + 1) % mod;
    }
    for (int i = 1; i <= m; ++i) {
        f >> x >> y;
        assert(x != y);
        v[x].push_back(y);
        r[y].push_back(x);
    }
    bfs(v, 1, 0);
    bfs(r, n, 1);
    bf(1);
    edges_cnt = 0;
    dp[1] = 1;
    memset(viz, 0, sizeof(viz));
    for (int lvl = 1; lvl <= D[0][n]; ++lvl) {
        lvl_cnt = 0;
        for (auto &it : niv[lvl]) {
            lvl_cnt += v[it].size();
        }
        for (auto &it : niv[lvl]) {
            nod_cnt = v[it].size();
            for (auto &it2 : v[it]) {
                if (D[0][it] + D[1][it2] + 1 == D[0][n]) {
                    dp[it2] += 1LL * dp[it] * P[nod_cnt - 1] % mod * comb(edges_cnt + nod_cnt, nod_cnt) % mod * comb(edges_cnt + lvl_cnt, lvl_cnt - nod_cnt) % mod * P[lvl_cnt - nod_cnt] % mod;
                    if (dp[it2] >= mod) {
                        dp[it2] -= mod;
                    }
                }
            }
        }
        edges_cnt += lvl_cnt;
    }
    g << dp[n];
    return 0;
}