#include <bits/stdc++.h>
using namespace std;
#define VI vector<int>
const int INF = 1e9;
const int MOD = 1e9 + 7;

VI getDist(int source, vector<VI> &G) {
    int n = G.size();
    vector<int> d(n, INF);
    
    queue<int> Q;
    d[source] = 0;

    Q.push(source);
    
    while(!Q.empty()) {
        int node = Q.front();
        Q.pop();
        for(auto temp : G[node]) 
            if(d[temp] > d[node] + 1) {
                d[temp] = d[node] + 1;
                Q.push(temp);
            }
    }

    return d;
}

int main() {
    
    ifstream cin("shuffle.in");
    //ofstream cout("shuffle.out");

    int n, m; cin >> n >> m;
    
    vector<pair<int, int>> E(m);

    for(int i = 0; i < m; ++i) {
        cin >> E[i].first >> E[i].second;
        E[i].first--, E[i].second--;
    }
    
    vector<VI> G(n, VI()), T(n, VI());
    
    for(auto edge : E) {
        G[edge.first].push_back(edge.second);
        T[edge.second].push_back(edge.first);
    }

    VI sourceDist = getDist(0, G);
    VI destDist = getDist(n - 1, T);
    
    vector<pair<int, int>> valid;
    vector<int> tip;

    for(auto edge : E)
        if(sourceDist[edge.first] < INF && destDist[edge.second] < INF) { // arcele care sunt pe cel putin un drum
            valid.push_back(edge);
            if(sourceDist[edge.first] + destDist[edge.second] + 1 == sourceDist[n - 1]) 
                tip.push_back(1); // cele care sunt pe un drum MINIM
            else
                tip.push_back(0);
        }
    
    int trash = m - int(valid.size()); // arcele care nu sunt pe niciun drum de la 0 la n - 1
    E = valid;
     
    int ans = 1;
    
    for(int i = 0; i < trash; ++i) // arcele trash pot fi oriunde, inmultim raspunsul cu aranjamente (n, trash.size())
        ans = 1LL * ans * (m - i) % MOD; 
    
    G = vector<VI> (n, VI());
    
    vector<VI> Depth(n, VI()), type(n, VI());

    for(int i = 0; i < (int) E.size(); ++i) {
        auto edge = E[i];
        G[edge.first].push_back(edge.second);
        type[edge.first].push_back(tip[i]);
    }

    for(int i = 0; i < n; ++i) {
        if(sourceDist[i] < INF && destDist[i] < INF)
            Depth[sourceDist[i]].push_back(i);
    }
        
    vector<int> dp(n, 0);
    vector<int> fact(m + 1, 1), inv(m + 1, 1), invfact(m + 1, 1);
    
    for(int i = 1; i <= m; ++i)
        fact[i] = 1LL * fact[i - 1] * i % MOD;
    for(int i = 2; i <= m; ++i)
        inv[i] = (MOD - 1LL * (MOD / i) * inv[MOD % i] % MOD) % MOD;
    for(int i = 1; i <= m; ++i)
        invfact[i] = 1LL * invfact[i - 1] * inv[i] % MOD;
        
    auto Comb = [&] (int n, int k) {
        int ans = 1LL * fact[n] * invfact[k] % MOD;
        return 1LL * ans * invfact[n - k] % MOD;
    };

    
    int doneEdges = 0;
    
    for(int i = n - 1; i >= 0; --i) {
        int allEdges = 0;

        for(auto node : Depth[i]) {
            allEdges += G[node].size();
        }

        for(auto node : Depth[i]) {
            int sz = G[node].size();
            if(sz == 0)
                continue;

            int coef = 1LL * fact[sz - 1] * fact[allEdges - sz] % MOD;
            coef = 1LL * coef * Comb(allEdges, sz) % MOD;
            coef = 1LL * coef * Comb(doneEdges + allEdges, allEdges) % MOD;

            for(int j = 0; j < (int) G[node].size(); ++j) {
                int son = G[node][j];
                if(type[node][j] == 0)
                    continue;
                dp[node] += 1LL * dp[son] * coef % MOD;
                dp[node] %= MOD;
            }    
        }
    
        doneEdges += allEdges;

        if(i == sourceDist[n - 1]) {
            dp[n - 1] = fact[doneEdges];
        }
    }
    
    cout << 1LL * ans * dp[0] % MOD << "\n";
}
