#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <queue>
#include <cassert>
using namespace std;

const int nmax = 200010, mod = 1000000007;

int n, m, to[nmax], from[nmax], fact[nmax];
vector<int> g[2][nmax];
int distStart[nmax], distEnd[nmax], dp[nmax], badEdges, notTooBadEdges;
int levelE[nmax], sumE[nmax];
vector<int> nodes[nmax];

int lgpow(int n, int p)
{
	if (!p) return 1;
	if (p % 2) return (1LL * n * lgpow(n, p - 1)) % mod;
	int x = lgpow(n, p / 2);
	return (1LL * x * x) % mod;
}

int comb(int n, int k)
{
	if (n < 0 || k < 0 || n < k) return 0;
	if (k == 0 || k == n) return 1;
	int up = fact[n], down = (1LL * fact[k] * fact[n - k]) % mod;
	return (1LL * up * lgpow(down, mod - 2)) % mod;
}

void bfs(int startNode, int dist[nmax], int indexG)
{
	for (int i = 1; i <= n; ++ i)
		dist[i] = -1;
	dist[startNode] = 0;
	queue<int> q;
	q.push(startNode);

	while (!q.empty())
	{
		int node = q.front();
		q.pop();

		for (int i = 0; i < g[indexG][node].size(); ++ i)
		{
			int vec = g[indexG][node][i];
			if (dist[vec] == -1)
			{
				dist[vec] = dist[node] + 1;
				q.push(vec);
			}
		}
	}
}

void processEdges()
{
	for (int i = 1; i <= m; ++ i)
	{
		int level = 1 + distStart[ from[i] ];
		levelE[level] ++;
	}

	for (int i = n; i > 0; -- i)
		sumE[i] = sumE[i + 1] + levelE[i];

	dp[n] = fact[ sumE[ distStart[n] + 1] ];
}

int main()
{
	freopen("shuffle.in", "r", stdin);
	freopen("shuffle.out", "w", stdout);

	scanf("%i %i", &n, &m);

	for (int i = 1; i <= m; ++ i)
	{
		scanf("%i %i", &from[i], &to[i]);
		g[0][from[i]].push_back(to[i]);
		g[1][to[i]].push_back(from[i]);
	}

	bfs(1, distStart, 0);
	bfs(n, distEnd, 1);

	fact[0] = 1;
	for (int i = 1; i < nmax; ++ i)
		fact[i] = (1LL * fact[i - 1] * i) % mod;

	processEdges();

	for (int i = 1; i <= n; ++ i)
		nodes[ distStart[i] + 1 ].push_back(i);
	
	for (int i = n; i; -- i)
		for (int j = 0; j < nodes[i].size(); ++ j)
		{
			int node = nodes[i][j];
			if (node == n) continue;

			int sumDp = 0, e = g[0][node].size();
			for (int i = 0; i < g[0][node].size(); ++ i)
			{
				int vec = g[0][node][i];

				if (distStart[node] + 1 + distEnd[vec] == distStart[n])
					 sumDp = (sumDp + dp[vec]) % mod;
			}

			dp[node] = sumDp;
			int level = distStart[node] + 1;

			dp[node] = (1LL * dp[node] * fact[sumE[level]]) % mod;
			dp[node] = (1LL * dp[node] * lgpow(e, mod - 2)) % mod;
			dp[node] = (1LL * dp[node] * lgpow(fact[sumE[level + 1]], mod - 2)) % mod;
		}

	printf("%d\n", (1LL * comb(m, badEdges) * dp[1]) % mod);
}