#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

const int NMAX = 3e4 + 5;
const int MMAX = 3e4 + 5;
const int MOD = 1e9 + 7;
const int INF = 1 << 29;

int n, m, garbage;
int fact[MMAX], inv[MMAX];
int d1[NMAX], d2[NMAX];
int dp[NMAX];
bool viz[NMAX], good[MMAX];

vector<int> tsort;
vector<pii> v[NMAX], g[NMAX], V[NMAX];

bitset<MMAX> sub[NMAX];

queue<int> q;

void read() {
    scanf("%d%d", &n, &m);

    for (int i = 1; i <= m; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        v[x].pb(mp(y, i));
        g[y].pb(mp(x, i));
    }
}

int lgpow(int a, int b, int mod) {
    int r = 1;
    for (int i = 0; (1LL << i) <= b; i++) {
        if ((1LL << i) & b)
            r = (1LL * r * a) % mod;
        a = (1LL * a * a) % mod;
    }
    return r;
}

void precalc() {
    fact[0] = inv[0] = 1;
    for (int i = 1; i <= m; i++) {
        fact[i] = (1LL * fact[i - 1] * i) % MOD;
        inv[i] = lgpow(fact[i], MOD - 2, MOD);
    }
}

void bfs1(int source) {
    for (int i = 1; i <= n; i++)
        d1[i] = INF;

    q.push(source);
    d1[source] = 0;
    while (!q.empty()) {
        int x = q.front();
        q.pop();

        for (auto it : v[x]) {
            if (d1[it.fi] == INF) {
                q.push(it.fi);
                d1[it.fi] = d1[x] + 1;
            }
        }
    }
}

void bfs2(int source) {
    for (int i = 1; i <= n; i++)
        d2[i] = INF;

    q.push(source);
    d2[source] = 0;
    while (!q.empty()) {
        int x = q.front();
        q.pop();

        for (auto it : g[x]) {
            if (d2[it.fi] == INF) {
                q.push(it.fi);
                d2[it.fi] = d2[x] + 1;
            }
        }
    }
}

void clean() {
    bfs1(1);
    bfs2(n);

    m = 0;
    for (int i = 1; i <= n; i++) {
        for (auto it : v[i]) {
            if (d1[i] != INF && d2[it.fi] != INF) {
                V[i].pb(mp(it.fi, ++m));

                if (d1[i] + d2[it.fi] + 1 == d1[n]) {
                    good[m] = 1;
                }
            } else {
                garbage++;
            }
        }
    }
}

void dfs(int x) {
    viz[x] = 1;
    for (auto it : V[x]) {
        if (!viz[it.fi]) {
            dfs(it.fi);
        }
    }
    tsort.pb(x);
}

void solve() {
    dfs(1);

    for (int i = 0; i < (int)tsort.size(); i++) {
        int x = tsort[i];

        if (V[x].empty()) {
            dp[x] = 1;
            continue;
        }

        for (auto it : V[x]) {
            sub[x] |= sub[it.fi];
            sub[x][it.se] = 1;
        }

        int total = sub[x].count();

        for (auto it : V[x]) {
            if (good[it.se]) {
                int edges_sub = sub[it.fi].count();
                int edges_neighbour = V[x].size() - 1;
                int edges_remaining = total - edges_sub - edges_neighbour - 1;

                int now = (1LL * dp[it.fi] * fact[edges_neighbour]) % MOD;
                now = (1LL * now * fact[edges_remaining]) % MOD;
                now = (1LL * now * fact[total]) % MOD;
                now = (1LL * now * inv[edges_sub]) % MOD;
                now = (1LL * now * inv[edges_neighbour + 1]) % MOD;
                now = (1LL * now * inv[edges_remaining]) % MOD;

                dp[x] = (dp[x] + now) % MOD;
            }
        }
    }

    int total = m + garbage;
    int ans = (1LL * dp[1] * fact[garbage]) % MOD;
    ans = (1LL * ans * fact[total]) % MOD;
    ans = (1LL * ans * inv[m]) % MOD;
    ans = (1LL * ans * inv[garbage]) % MOD;

    printf("%d\n", ans);
}

int main() {
    cin.sync_with_stdio(false);
    freopen("shuffle.in", "r", stdin);

    read();
    precalc();
    clean();
    solve();

    return 0;
}
